%global gem_name jekyll

Name: rubygem-%{gem_name}
Version: 3.8.2
Release: 1%{?dist}
Summary: A simple, blog aware, static site generator
License: MIT
URL: https://github.com/jekyll/jekyll
Source0: https://rubygems.org/gems/%{gem_name}-%{version}.gem
# Tests are not present in upstream gem, adding them manually
# git clone https://github.com/jekyll/jekyll.git
# cd jekyll/
# git checkout v3.8.2
#
# tar -czf rubygem-jekyll-3.8.2-specs.tgz test/
Source1:	rubygem-jekyll-%{version}-specs.tgz
# tar -czf rubygem-jekyll-3.8.2-features.tgz features/
Source2:	rubygem-jekyll-%{version}-features.tgz

BuildArch:	noarch
BuildRequires:	help2man
BuildRequires:	ruby(release)
BuildRequires:	rubygem(bigdecimal)
BuildRequires:	rubygem(addressable) >= 2.4
BuildRequires:	rubygem(colorator)
BuildRequires:	rubygem(jekyll-sass-converter)
BuildRequires:	rubygem(jekyll-watch) >= 2.0
BuildRequires:	rubygem(kramdown)
BuildRequires:	rubygem(liquid) >= 4.0
BuildRequires:	rubygem(mercenary)
BuildRequires:	rubygem(pathutil)
BuildRequires:	rubygem(rouge)
BuildRequires:	rubygem(safe_yaml)
BuildRequires:	rubygems-devel
BuildRequires:	rubygem(http_parser.rb)
BuildRequires:	rubygem(em-websocket)
BuildRequires:	rubygem(eventmachine)
Requires:	rubygem(json)

# Test dependencies
BuildRequires:	rubygem(nokogiri)
BuildRequires:	rubygem(minitest)
BuildRequires:	rubygem(rspec-mocks)
BuildRequires:	rubygem(rdiscount)
BuildRequires:	rubygem(redcarpet)
BuildRequires:	rubygem(shoulda)
BuildRequires:	rubygem(cucumber)
BuildRequires:	rubygem(rspec-its)
BuildRequires:	rubygem(httpclient)

%description
Jekyll is a simple, blog aware, static site generator.


%package doc
Summary: Documentation for %{name}
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{name}.

%prep
gem unpack %{SOURCE0}

%setup -q -n  %{gem_name}-%{version}

%build
# Create the gem as gem install only works on a gem file
gem build ../%{gem_name}-%{version}.gemspec

# %%gem_install compiles any C extensions and installs the gem into ./%%gem_dir
# by default, so that we can move it into the buildroot in %%install
%gem_install

%install
%{__mkdir} -p %{buildroot}%{_bindir} %{buildroot}%{gem_dir}		\
	%{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/


mkdir -p %{buildroot}%{_bindir}
cp -pa .%{_bindir}/* \
        %{buildroot}%{_bindir}/

find %{buildroot}%{gem_instdir}/exe -type f | xargs chmod a+x

help2man -N -s1 -o %{buildroot}%{_mandir}/man1/%{gem_name}.1	\
	%{buildroot}/usr/share/gems/gems/%{gem_name}-%{version}/exe/%{gem_name}

%check
pushd .%{gem_instdir}
tar xzvf %{SOURCE1}

# We don't care about code coverage.
sed -i '/^if ENV\["CI"\]$/,/^end$/ s/^/#/' test/helper.rb

# We don't have minitest-reporters in Fedora yet.
sed -i '/minitest\/reporters/ s/^/#/' test/helper.rb
sed -i '/^Minitest::Reporters.use! \[$/,/^\]$/ s/^/#/' test/helper.rb

# We don't have minitest-profile in Fedora yet.
sed -i '/minitest\/profile/ s/^/#/' test/helper.rb

ruby -Itest -e 'Dir.glob "./test/**/test_*.rb", &method(:require)' || :

tar xzvf %{SOURCE2}
cucumber ./features || :

popd

%files
%dir %{gem_instdir}
%{_bindir}/jekyll
%{_mandir}/man1/%{gem_name}.1*
%exclude %{gem_instdir}/.rubocop.yml
%exclude %{gem_instdir}/rubocop/
%license %{gem_instdir}/LICENSE
%{gem_instdir}/exe
%{gem_libdir}
%exclude %{gem_cache}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/README.markdown

%changelog
* Sun May 20 2018 Frantisek Zatloukal <fzatlouk@redhat.com> - 3.8.2-1
- Update Jekyll to 3.8.2

* Mon May 07 2018 Frantisek Zatloukal <fzatlouk@redhat.com> - 3.8.1-2
- Add BuildRequires rubygem(httpclient)

* Mon May 07 2018 Frantisek Zatloukal <fzatlouk@redhat.com> - 3.8.1-1
- Update Jekyll to 3.8.1

* Wed Jan 31 2018 Frantisek Zatloukal <fzatlouk@redhat.com> - 3.7.2-1
- Update Jekyll to 3.7.2

* Sat Sep 23 2017 Frantisek Zatloukal <fzatlouk@redhat.com> - 3.6.0-1
- Recreated -spec file with gem2rpm
- Update Jekyll to 3.6.0
- Enable Tests (still not working properly)
- Updated spec with fixes from Review, thanks zebob.m@gmail.com

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.2.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Wed Jul 19 2017 Frantisek Zatloukal <fzatlouk@redhat.com> - 3.5.1-1
- Update Jekyll to 3.5.1
- Add BuildRequires: rubygem(addressable)

* Thu Jul 13 2017 Frantisek Zatloukal <fzatlouk@redhat.com> - 3.5.0-1
- Update Jekyll to 3.5.0

* Sun Apr 09 2017 Björn Esser <besser82@fedoraproject.org> - 3.2.1-3
- Add explicit Requires: rubygem(json)

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.2.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Aug 24 2016 Björn Esser <fedora@besser82.io> - 3.2.1-1
- initial import (#1368851)

* Sun Aug 21 2016 Björn Esser <fedora@besser82.io> - 3.2.1-0.1
- initial rpm-release (#1368851)
